# Split, apply, combine

[![CI](https://github.com/JuliaData/SplitApplyCombine.jl/workflows/CI/badge.svg)](https://github.com/JuliaData/SplitApplyCombine.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaData/SplitApplyCombine.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaData/SplitApplyCombine.jl)
[![deps](https://juliahub.com/docs/SplitApplyCombine/deps.svg)](https://juliahub.com/ui/Packages/SplitApplyCombine/vbX6o?t=2)
[![version](https://juliahub.com/docs/SplitApplyCombine/version.svg)](https://juliahub.com/ui/Packages/SplitApplyCombine/vbX6o)
[![pkgeval](https://juliahub.com/docs/SplitApplyCombine/pkgeval.svg)](https://juliahub.com/ui/Packages/SplitApplyCombine/vbX6o)


*Strategies for nested data in Julia*

*SplitApplyCombine.jl* provides high-level, generic tools for manipulating data -
particularly focussing on data in nested containers. An emphasis is placed on ensuring
split-apply-combine strategies are easy to apply, and work reliably for arbitrary iterables
and in an optimized way with the data structures included in Julia's standard library.

The tools come in the form of high-level functions that operate on iterable or indexable
containers in an intuitive and simple way, extending Julia's in-built `map`, `reduce` and
`filter` commands to a wider range of operations. Just like these `Base` functions, the
functions here like `invert`, `group` and `innerjoin` are able to be overloaded and
optimized by users and the maintainers of other packages for their own, custom data
containers.

One side goal is to provide sufficient functionality to satisfy the need to manipulate
"relational" data (meaning tables and dataframes) with basic in-built Julia data containers
like `Vector`s of `NamedTuple`s and higher-level functions in a "standard" Julia style.
Pay particular to the `invert` family of functions, which effectively allows you to switch
between a "struct-of-arrays" and an "array-of-structs" interpretation of your data. I am
exploring the idea of using arrays of named tuples for a fast table package in another
package under development called
[MinimumViableTables](https://github.com/andyferris/MinimumViableTables.jl)), which adds
acceleration indexes but otherwise attempts to use a generic "native Julia" interface.

## Quick start

You can install the package by typing
`Pkg.add("SplitApplyCombine")` at the REPL.

Below are some simple examples of how a select subset of the tools can be used to split,
manipulate, and combine data. A complete API reference is included at the end of this
README.

```julia
julia> using SplitApplyCombine

julia> only([3]) # return the one-and-only element of the input (included in Julia 1.4)
3

julia> splitdims([1 2 3; 4 5 6]) # create nested arrays
3-element Array{Array{Int64,1},1}:
 [1, 4]
 [2, 5]
 [3, 6]

julia> combinedims([[1, 4], [2, 5], [3, 6]]) # flatten nested arrays
2×3 Array{Int64,2}:
 1  2  3
 4  5  6

 julia> invert([[1,2,3],[4,5,6]]) # invert the order of nesting
3-element Array{Array{Int64,1},1}:
 [1, 4]
 [2, 5]
 [3, 6]

julia> group(iseven, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]) # split elements into groups
2-element Dictionary{Bool,Array{Int64,1}}
 false │ [1, 3, 5, 7, 9]
  true │ [2, 4, 6, 8, 10]

julia> groupreduce(iseven, +, 1:10) # like above, but performing reduction
2-element Dictionary{Bool,Int64}
 false │ 25
  true │ 30

julia> innerjoin(iseven, iseven, tuple, [1,2,3,4], [0,1,2]) # combine two datasets - related to SQL `inner join`
6-element Array{Tuple{Int64,Int64},1}:
 (1, 1)
 (2, 0)
 (2, 2)
 (3, 1)
 (4, 0)
 (4, 2)

julia> leftgroupjoin(iseven, iseven, tuple, [1,2,3,4], [0,1,2]) # efficient groupings from two datasets
Dict{Bool,Array{Tuple{Int64,Int64},1}} with 2 entries:
  false => Tuple{Int64,Int64}[(1, 1), (3, 1)]
  true  => Tuple{Int64,Int64}[(2, 0), (2, 2), (4, 0), (4, 2)]
```

## Tabular data

The primary interface for manipulating tabular data is the *relational algebra*. A
*relation* is typically defined as an (unordered) collection of (unique) (named) tuples. 
If relations are collections of rows, and tables are to be viewed as relations, then I
suggest that tables should be viewed as collections of rows (and in particular they should
iterate rows and return an entire row from `getindex`, if defined).

While simple, this already allows quite a bit of relational algebra to occur. One can then
`filter` rows of a table, `map` rows of a table (to project, rename or create columns), and
use `zip` and `product` iterables for more complex operations. The goal below will be to
discuss functions which work well for general iterables *and* will be useful for a table
that iterates rows. As a prototype to keep in mind for this work, I consider an 
`AbstractVector{<:NamedTuple}` to be a good model of (strongly-typed) a table/dataframe.
Specialized packages may provide convenient macro-based DSLs, a greater range of functions,
and implementations that focus on things such as out-of-core or distributed computing, more
flexible acceleration indexing, etc. Here I'm only considering the basic, bare-bones API
that may be extended and built upon by other packages.

## Notes

This package recently switched from using the dictionaries in `Base` to those in the
[*Dictionaries.jl*](https://github.com/andyferris/Dictionaries.jl) package, particularly
for the `group` family of functions.

# API reference

The package currently implements and exports `only`, `splitdims`, `splitdimsview`,
`combinedims`, `combinedimsview`, `mapview`, `filterview`, `mapmany`, `flatten`, `group`, `groupinds`, `groupview`,
`groupreduce`, `innerjoin` and `leftgroupjoin`, as well as the `@_` macro. Expect this list
to grow.

## Generic operations on collections

### `only(iter)`

Returns the single, one-and-only element of the collection `iter`. If it contains zero
elements or more than one element, an error is thrown.

#### Example:

```julia
julia> only([3])
3

julia> only([])
ERROR: ArgumentError: Collection must have exactly one element (input was empty)
Stacktrace:
 [1] only(::Array{Any,1}) at /home/ferris/.julia/v0.7/SAC/src/only.jl:4

julia> single([3, 10])
ERROR: ArgumentError: Collection must have exactly one element (input contained more than one element)
Stacktrace:
 [1] only(::Array{Int64,1}) at /home/ferris/.julia/v0.7/SAC/src/only.jl:10
```

### `splitdims(array, [dims])`

Split a multidimensional array into nested arrays of arrays, splitting the specified 
dimensions `dims` to the "outer" array, leaving the remaining dimension in the "inner"
array. By default, the last dimension is split into the outer array.

#### Examples:

```julia
julia> splitdims([1 2; 3 4])
2-element Array{Array{Int64,1},1}:
 [1, 3]
 [2, 4]

julia> splitdims([1 2; 3 4], 1)
2-element Array{Array{Int64,1},1}:
 [1, 2]
 [3, 4]
```

### `splitdimsview(array, [dims])`

Like `splitdimsview(array, dims)` except creating a lazy view of the nested struture.

### `combinedims(array)`

The inverse operation of `splitdims` - this will take a nested array of arrays, where 
each sub-array has the same dimensions, and combine them into a single, flattened array.

#### Example:

```julia
julia> combinedims([[1, 2], [3, 4]])
2×2 Array{Int64,2}:
 1  3
 2  4
```

### `combinedimsview(array)`

Like `combinedims(array)` except creating a lazy view of the flattened struture.

### `invert(a)`

Take a nested container `a` and return a container where the nesting is reversed, such that
`invert(a)[i][j] === a[j][i]`.

Currently implemented for combinations of `AbstractArray`, `Tuple` and `NamedTuple`. It is
planned to add `AbstractDict` in the future.

#### Examples:

```julia
julia> invert([[1,2,3],[4,5,6]]) # invert the order of nesting
3-element Array{Array{Int64,1},1}:
 [1, 4]
 [2, 5]
 [3, 6]

julia> invert((a = [1, 2, 3], b = [2.0, 4.0, 6.0])) # Works between different data types
3-element Array{NamedTuple{(:a, :b),Tuple{Int64,Float64}},1}:
 (a = 1, b = 2.0)
 (a = 2, b = 4.0)
 (a = 3, b = 6.0)
```

### `invert!(out, a)`

A mutating version of `invert`, which stores the result in `out`.

### `mapview(f, iter)`

Like `map`, but presents a view of the data contained in `iter`. The result may be wrapped in an
lazily-computed output container (generally attempting to preserve arrays as `AbstractArray`, and
so-on).

For immutable collections (like `Tuple` and `NamedTuple`), the operation may be performed eagerly.

#### Example:

```julia
julia> a = [1,2,3];

julia> b = mapview(iseven, a)
3-element MappedArray{Bool,1,typeof(iseven),Array{Int64,1}}:
 false
  true
 false

julia> a[1] = 2;

julia> b
3-element MappedArray{Bool,1,typeof(iseven),Array{Int64,1}}:
  true
  true
 false
```

### `filterview(f, arr)`

Like `filter`, but presents a view of the data contained in `arr`. Data in `arr` is not copied, and modifications to the resulting view are propagated to the original array.

#### Example:

```julia
julia> a = [1, 2, 3];

julia> b = filterview(isodd, a)
2-element view(::Vector{Int64}, [1, 3]) with eltype Int64:
 1
 3

julia> b[2] = 10;

julia> a
3-element Vector{Int64}:
  1
  2
 10

julia> b
2-element view(::Vector{Int64}, [1, 3]) with eltype Int64:
  1
 10
```

### `mapmany(f, iters...)`

Like `map`, but `f(x...)` for each `x ∈ zip(iters...)` may return an arbitrary number of 
values to insert into the output.

#### Example:

```julia
julia> mapmany(x -> 1:x, [1,2,3])
6-element Array{Int64,1}:
 1
 1
 2
 1
 2
 3
```

(Note that, semantically, `filter` could be thought of as a special case of `mapmany`.)

### `flatten(a)`

Takes a collection of collections `a` and returns a collection containing all the elements
of the subcollecitons of `a`. Equivalent to `mapmany(identity, a)`.

#### Example:

```julia
julia> flatten([1:1, 1:2, 1:3])
6-element Array{Int64,1}:
 1
 1
 2
 1
 2
 3
```

### `product(f, a, b)`

Takes the Cartesian outer product of two containers and evaluates `f` on all pairings of
elements.

For example, if `a` and `b` are vectors, this returns a matrix `out` such that
`out[i,j] = f(a[i], b[j])` for `i in keys(a)` and `j in keys(b)`.

Note this interface differs slightly from `Iterators.product` where `f = tuple` is assumed.

#### Example:

```julia
julia> product(+, [1,2], [1,2,3])
2×3 Array{Int64,2}:
 2  3  4
 3  4  5
```

### `productview(f, a, b)`

Like `product`, but return a view of the Cartesian product of `a` and `b` where the output elements are `f`
evaluated with the corresponding of `a` and `b`.

#### Example

```julia
julia> productview(+, [1,2], [1,2,3])
2×3 ProductArray{Int64,2,typeof(+),Array{Int64,1},Array{Int64,1}}:
 2  3  4
 3  4  5
```

## Grouping

These operations help you split the elements of a collection according to an arbitrary
function which maps each element to a group key.

### `group([by = identity], [f = identity], iter)`

Group the elements `x` of the iterable `iter` into groups labeled by `by(x)`, transforming
each element . The default implementation creates a `Dictionaries.Dictionary` of
`Vector`s, but of course a table/dataframe package might extend this to return a suitable
(nested) structure of tables/dataframes.

Also a `group(by, f, iters...)` method exists for the case where multiple iterables of the
same length are provided.

#### Examples:
```julia
julia> group(iseven, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
2-element Dictionary{Bool,Array{Int64,1}}
 false │ [1, 3, 5, 7, 9]
  true │ [2, 4, 6, 8, 10]

julia> names = ["Andrew Smith", "John Smith", "Alice Baker", "Robert Baker",
                "Jane Smith", "Jason Bourne"]
6-element Array{String,1}:
 "Andrew Smith"
 "John Smith"
 "Alice Baker"
 "Robert Baker"
 "Jane Smith"
 "Jason Bourne"

julia> group(last, first, split.(names))
3-element Dictionary{SubString{String},Array{SubString{String},1}}
  "Smith" │ SubString{String}["Andrew", "John", "Jane"]
  "Baker" │ SubString{String}["Alice", "Robert"]
 "Bourne" │ SubString{String}["Jason"]
```

### `groupfind(by, container)`

For *indexable* collections `container`, returns the indices/keys associated with each group.

**NOTE: Recently renamed from `groupinds`.**

#### Example:

```julia
julia> groupfind(iseven, [3,4,2,6,5,8])
2-element Dictionary{Bool,Array{Int64,1}}
 false │ [1, 5]
  true │ [2, 3, 4, 6]

```

### `groupview(by, iter)`

Similar to `group(by, iter)` but the grouped elements are a view of the original collection.
Uses `groupinds` to construct the appropriate container.

#### Example:

```julia
julia> v = [3,4,2,6,5,8]
6-element Array{Int64,1}:
 3
 4
 2
 6
 5
 8

julia> groups = groupview(iseven, v)
2-element GroupDictionary{Bool,SubArray{Int64,1,Array{Int64,1},Tuple{Array{Int64,1}},false},Array{Int64,1},Dictionary{Bool,Array{Int64,1}}}
 false │ [3, 5]
  true │ [4, 2, 6, 8]

julia> groups[false][:] .= 99
2-element view(::Array{Int64,1}, [1, 5]) with eltype Int64:
 99
 99

julia> v
6-element Array{Int64,1}:
 99
  4
  2
  6
 99
  8
```

### `groupreduce(by, [f = identity], op, iter...; [init])`

Applies a `mapreduce`-like operation on the groupings labeled by passing the elements of
`iter` through `by`. Mostly equivalent to `map(g -> reduce(op, g; init=init), group(by, f, iter))`,
but designed to be more efficient. If multiple collections (of the same length) are
provided, the transformations `by` and `f` occur elementwise.

We also export `groupcount`, `groupsum` and `groupprod` as special cases of the above, to determine
the number of elements per group, their sum, and their product, respectively.

#### Examples:
```julia
julia> groupreduce(iseven, +, 1:10)
Dictionary{Bool,Int64} with 2 entries:
  false │ 25
  true  │ 30

julia> groupcount(iseven, 1:10)
Dictionary{Bool,Int64} with 2 entries:
  false │ 5
  true  │ 5
```


## Joining

### `innerjoin([lkey = identity], [rkey = identity], [f = tuple], [comparison = isequal], left, right)`

Performs a relational-style join operation between iterables `left` and `right`, returning
a collection of elements `f(l, r)` for which `comparison(lkey(l), rkey(r))` is `true` where
`l ∈ left`, `r ∈ right.`

#### Example:

```julia
julia> innerjoin(iseven, iseven, tuple, ==, [1,2,3,4], [0,1,2])
6-element Array{Tuple{Int64,Int64},1}:
 (1, 1)
 (2, 0)
 (2, 2)
 (3, 1)
 (4, 0)
 (4, 2)
```

### `leftgroupjoin([lkey = identity], [rkey = identity], [f = tuple], [comparison = isequal], left, right)`

Creates a collection if groups labelled by `lkey(l)` where each group contains elements
`f(l, r)` which satisfy `comparison(lkey(l), rkey(r))`. If there are no matches, the group
is still created (with an empty collection).

This operation shares similarities with an SQL left outer join, but is more similar to
LINQ's `GroupJoin`.

#### Example:

```julia
julia> leftgroupjoin(iseven, iseven, tuple, ==, [1,2,3,4], [0,1,2])
Dictionary{Bool,Array{Tuple{Int64,Int64},1}} with 2 entries:
  false │ Tuple{Int64,Int64}[(1, 1), (3, 1)]
  true  │ Tuple{Int64,Int64}[(2, 0), (2, 2), (4, 0), (4, 2)]
```

leftgroupjoin(left, right) = leftgroupjoin(identity, identity, left, right)
leftgroupjoin(lkey::Callable, rkey::Callable, left, right) = leftgroupjoin(lkey, rkey, merge, left, right)
leftgroupjoin(lkey::Callable, rkey::Callable, f::Callable, left, right) = leftgroupjoin(lkey, rkey, f, isequal, left, right)

"""
    leftgroupjoin(lkey, rkey, f, comparison, left, right)

Creates a collection if groups labelled by `lkey(l)` where each group contains elements
`f(l, r)` which satisfy `comparison(lkey(l), rkey(r))`. If there are no matches, the group
is still created (with an empty collection).

This operation shares some similarities with an SQL left outer join.

### Example

```jldoctest
julia> leftgroupjoin(iseven, iseven, tuple, ==, [1,2,3,4], [0,1,2])
Dictionary{Bool,Array{Tuple{Int64,Int64},1}} with 2 entries:
  false │ Tuple{Int64,Int64}[(1, 1), (3, 1)]
  true  │ Tuple{Int64,Int64}[(2, 0), (2, 2), (4, 0), (4, 2)]
```
"""
function leftgroupjoin(lkey::Callable, rkey::Callable, f::Callable, comparison::Callable, left, right)
    # The O(length(left)*length(right)) generic method when nothing about `comparison` is known

    # TODO Do this inference-free, like comprehensions...
    T = Core.Compiler.return_type(f, Tuple{eltype(left), eltype(right)})
    K = Core.Compiler.return_type(lkey, Tuple{eltype(left)})
    V = Vector{T}
    out = Dictionary{K, V}()
    for a ∈ left
        key = lkey(a)
        group = get!(V, out, key)
        for b ∈ right
            if comparison(key, rkey(b))
                push!(group, f(a, b))
            end
        end
    end
    return out
end

function leftgroupjoin(lkey::Callable, rkey::Callable, f::Callable, ::typeof(isequal), left, right)
    # isequal heralds a hash-based approach, roughly O(length(left) * log(length(right)))

    # TODO Do this inference-free, like comprehensions...
    T = Core.Compiler.return_type(f, Tuple{eltype(left), eltype(right)})
    K = Core.Compiler.return_type(rkey, Tuple{eltype(right)})
    V = eltype(right)
    dict = Dictionary{K,Vector{V}}() # maybe a different stategy if right is unique
    for b ∈ right
        key = rkey(b)
        push!(get!(Vector{V}, dict, key), b)
    end

    K2 = Core.Compiler.return_type(lkey, Tuple{eltype(left)})
    out = Dictionary{K2, Vector{T}}()
    for a ∈ left
        key = lkey(a)
        token = gettoken(out, key)
        group = get!(Vector{T}, out, key)
        (has_index, token) = gettoken(dict, key)
        if has_index
            for b ∈ gettokenvalue(dict, token)
                push!(group, f(a, b))
            end
        end
    end
    return out
end

"""
    invert(a)

Return a new nested container by reversing the order of the nested container `a`, for
example turning a dictionary of arrays into an array of dictionaries, such that 
`a[i][j] === invert(a)[j][i]`.

Note that in order for the keys of the inner and outer structure to be known, the input
container `a` must not be empty. 

# Examples

```julia
julia> invert([[1,2,3],[4,5,6]])
3-element Array{Array{Int64,1},1}:
 [1, 4]
 [2, 5]
 [3, 6]

julia> invert((a = [1, 2, 3], b = [2.0, 4.0, 6.0]))
3-element Array{NamedTuple{(:a, :b),Tuple{Int64,Float64}},1}:
 (a = 1, b = 2.0)
 (a = 2, b = 4.0)
 (a = 3, b = 6.0)
```
""" # Array-Array
@inline function invert(a::AbstractArray{T}) where {T <: AbstractArray}
    f = first(a)
    innersize = size(a)
    outersize = size(f)
    innerkeys = keys(a)
    outerkeys = keys(f)

    @boundscheck for x in a
        if size(x) != outersize
            error("keys don't match")
        end
    end

    out = Array{Array{eltype(T),length(innersize)}}(undef, outersize)
    @inbounds for i in outerkeys
        out[i] = Array{eltype(T)}(undef, innersize)
    end

    return _invert!(out, a, innerkeys, outerkeys)
end

@propagate_inbounds function invert!(out::AbstractArray, a::AbstractArray)
    innerkeys = keys(a)
    outerkeys = keys(first(a))

    @boundscheck for x in a
        if keys(x) != outerkeys
            error("keys don't match")
        end
    end

    @boundscheck if keys(out) != outerkeys
        error("keys don't match")
    end

    @boundscheck for x in out
        if keys(x) != innerkeys
            error("keys don't match")
        end
    end

    return _invert!(out, a, innerkeys, outerkeys)
end

# Note: keys are assumed verified already
function _invert!(out, a, innerkeys, outerkeys)
    @inbounds for i ∈ innerkeys
        tmp = a[i]
        for j ∈ outerkeys
            out[j][i] = tmp[j]
        end
    end
    return out
end

# Tuple-tuple
@inline function invert(a::NTuple{n, NTuple{m, Any}}) where {n, m}
    if @generated
        exprs = [:(tuple($([:(a[$j][$i]) for j in 1:n]...))) for i in 1:m]
        return :(tuple($(exprs...)))
    else
        ntuple(i -> ntuple(j -> a[j][i], Val(n)), Val(m))
    end
end


# Tuple-Array
@inline function invert(a::NTuple{n, AbstractArray}) where {n}
    arrayinds = keys(a[1])

    @boundscheck for x in a
        if keys(x) != arrayinds
            error("indices are not uniform")
        end
    end
    
    T = _eltypes(typeof(a))
    out = similar(first(a), T)

    @inbounds invert!(out, a)
end

@inline function invert!(out::AbstractArray{<:NTuple{n, Any}}, a::NTuple{n, AbstractArray}) where n
    @boundscheck for x in a
        if keys(x) != keys(out)
            error("indices do not match")
        end
    end

    if @generated
        return quote
            @inbounds for i in keys(out)
                out[i] = $(:(tuple($([:( a[$j][i] ) for j in 1:n]...))))
            end

            return out
        end
    else
        @inbounds for i in keys(out)
            out[i] = map(x -> @inbounds(x[i]), a)
        end

        return out
    end
end

# Note that T is a concrete type, so the AbstractArrays should have all their type parameters
@pure function _eltypes(::Type{T}) where {T <: Tuple{Vararg{AbstractArray}}}
    types = T.parameters
    eltypes = map(eltype, types)
    return Tuple{eltypes...}
end

struct Indexer{i}
end

Indexer(i::Int) = Indexer{i}()
(::Indexer{i})(x) where {i} = @inbounds x[i]

# Array-Tuple
@inline function invert(a::AbstractArray{<:NTuple{n, Any}}) where {n}
    if @generated
        exprs = [ :(map($(Indexer(i)), a)) for i in 1:n ]
        return :( tuple($(exprs...)) )
    else    
        ntuple(i -> map(x -> x[i], a), Val(n))
    end
end


# NamedTuple-NamedTuple
@inline function invert(a::NamedTuple{names1, <:Tuple{Vararg{NamedTuple{names2}}}}) where {names1, names2}
    if @generated
        exprs = [:(NamedTuple{names1}(tuple($([:(getfield(getfield(a, $(QuoteNode(n1))), $(QuoteNode(n2)))) for n1 in names1]...)))) for n2 in names2]
        return :(NamedTuple{names2}(tuple($(exprs...))))
    else
        NamedTuple{names2}(ntuple(i -> NamedTuple{names1}(ntuple(j -> getfield(getfield(a, names1[j]), names2[i]), Val(length(names1)))), Val(length(names2))))
    end
end


# NamedTuple-Array
@inline function invert(a::NamedTuple{names, <:Tuple{Vararg{AbstractArray}}}) where {names}
    arrayinds = keys(a[1])

    @boundscheck for x in a
        if keys(x) != arrayinds
            error("indices are not uniform")
        end
    end
    
    T = _eltypes(typeof(a))
    out = similar(first(a), NamedTuple{names, T})

    @inbounds invert!(out, a)
end

@inline function invert!(out::AbstractArray{<:NamedTuple{names}}, a::NamedTuple{names, <:Tuple{Vararg{AbstractArray}}}) where names
    @boundscheck for x in a
        if keys(x) != keys(out)
            error("indices do not match")
        end
    end

    if @generated
        return quote
            @inbounds for i in keys(out)
                out[i] = $(:(NamedTuple{names}(tuple($([:( a[$(QuoteNode(n))][i] ) for n in names]...)))))
            end

            return out
        end
    else
        @inbounds for i in keys(out)
            out[i] = map(x -> @inbounds(x[i]), a)
        end

        return out
    end
end

# TODO check that the AbstractArrays have all their type parameters
@pure function _eltypes(::Type{NamedTuple{names, T}}) where {names, T <: Tuple{Vararg{AbstractArray}}}
    types = T.parameters
    eltypes = map(eltype, types)
    return Tuple{eltypes...}
end


# Array-NamedTuple
struct GetFielder{name}
end

GetFielder(name::Symbol) = GetFielder{name}()
(::GetFielder{name})(x) where {name} = getfield(x, name)

@inline function invert(a::AbstractArray{<:NamedTuple{names}}) where {names}
    if @generated
        exprs = [ :(map($(GetFielder(n)), a)) for n in names ]
        return :( NamedTuple{names}(tuple($(exprs...))) )
    else    
        NamedTuple{names}(ntuple(i -> map(x -> getfield(x, names[i]), a), Val(length(names))))
    end
end

# NamedTuple-Tuple
@inline function invert(a::NamedTuple{names1, <:Tuple{Vararg{Any, n}}}) where {names1, n}
    if @generated
        exprs = [:(NamedTuple{names1}(tuple($([:(getfield(getfield(a, $(QuoteNode(n1))), $i)) for n1 in names1]...)))) for i in 1:n]
        return :(tuple($(exprs...)))
    else
        ntuple(i -> NamedTuple{names1}(ntuple(j -> getfield(getfield(a, names1[j]), i), Val(length(names1)))), Val(n))
    end
end

# Tuple-NamedTuple
@inline function invert(a::Tuple{Vararg{NamedTuple{names2}, n}}) where {n, names2}
    if @generated
        exprs = [:(tuple($([:(getfield(getfield(a, $i), $(QuoteNode(n2)))) for i in 1:n]...))) for n2 in names2]
        return :(NamedTuple{names2}(tuple($(exprs...))))
    else
        NamedTuple{names2}(ntuple(i -> ntuple(j -> getfield(getfield(a, j), names2[i]), Val(n)), Val(length(names2))))
    end
end

# Dict-Dict

# Dict-Array

# Array-Dict

# Dict-Tuple

# Tuple-Dict

# NamedTuple-Dict

# Dict-NamedTuple

function only(iter)
    i = iterate(iter)
    if i === nothing
        throw(ArgumentError("Collection must have exactly one element (input is empty)"))
    end
    (out, state) = i
    if iterate(iter, state) === nothing
        return out
    else
        throw(ArgumentError("Collection must have exactly one element (input contains more than one element)"))
    end
end

function only(::Tuple{})
    throw(ArgumentError("Collection must have exactly one element (input is empty)"))
end
function only(t::Tuple{Any})
    return t[1]
end
function only(::NTuple{N,Any}) where N
    throw(ArgumentError("Collection must have exactly one element (input has $N elements)"))
end

"""
    product(f, a, b)

Takes the Cartesian outer product of two containers and evaluates `f` on all pairings of
elements. 

For example, if `a` and `b` are vectors, this returns a matrix `out` such that
`out[i,j] = f(a[i], b[j])` for `i in keys(a)` and `j in keys(b)`. See also `productview`.

# Example

```julia
julia> product(+, [1,2], [1,2,3])
2×3 Array{Int64,2}:
 2  3  4
 3  4  5
```
"""
function product(f::Callable, a, b)
	out = similar(a, promote_op(f, eltype(a), eltype(b)), (axes(a)..., axes(b)...))
	return product!(f, out, a, b)
end

@inline function product!(f::Callable, out, a, b)
	axes_a = axes(a)
	axes_b = axes(b)
	axes_out = axes(out)

	@boundscheck if axes_out != (axes_a..., axes_b...)
	    throw(DimensionMismatch("Output does not match input dimensions"))
	end

	@inbounds for i_a in CartesianIndices(axes_a)
		for i_b in CartesianIndices(axes_b)
			i_out = CartesianIndex(i_a.I..., i_b.I...)
			out[i_out] = f(a[i_a], b[i_b])
		end
	end

	return out
end

struct ProductArray{T, N, F, A <: AbstractArray, B <: AbstractArray} <: AbstractArray{T, N}
	f::F
	a::A
	b::B
end

Base.IndexStyle(::Type{<:ProductArray}) = IndexCartesian()
Base.axes(p::ProductArray) = (axes(p.a)..., axes(p.b)...)
Base.size(p::ProductArray) = (size(p.a)..., size(p.b)...)
@propagate_inbounds function Base.getindex(p::ProductArray{T}, i::Int...) where {T}
	ndims_a = ndims(p.a)
	ndims_b = ndims(p.b)
	i_a = ntuple(j -> @inbounds(return i[j]), Val(ndims_a))
	i_b = ntuple(j -> @inbounds(return i[j + ndims_a]), Val(ndims_b))
	return p.f(p.a[i_a...], p.b[i_b...])::T
end

"""
    productview(f, a, b)

Return a view of a Cartesian product of `a` and `b` where the output elements are `f`
evaluated those of `a` and `b`. See also `product` and `ProductArray`

# Example

```julia
julia> productview(+, [1,2], [1,2,3])
2×3 ProductArray{Int64,2,typeof(+),Array{Int64,1},Array{Int64,1}}:
 2  3  4
 3  4  5
```
"""
function productview(f::Callable, a, b)
	T = promote_op(f, eltype(a), eltype(b))
	N = ndims(a) + ndims(b)
	return ProductArray{T, N, typeof(f), typeof(a), typeof(b)}(f, a, b)
end

"""
    combinedims(array_of_arrays)

Combine the dimensions of a nested array structure into a new, flat array.

This is the inverse operation of `splitdims` / `splitdimsview`.

See also `combinedimsview`, the lazy version of this function.

# Example

```julia
julia> combinedims([[1, 2], [3, 4]])
2×2 Array{Int64,2}:
 1  3
 2  4
```
"""
@inline combinedims(a::AbstractArray{<:AbstractArray{<:Any, N}, M}) where {N,M} = combinedims(a, ntuple(i -> N + i, M))
@inline combinedims(a::AbstractArray{<:AbstractArray{<:Any, N}, 1}, outerdim::Int) where {N} = _combinedims(a, Val((outerdim,)))
@inline combinedims(a::AbstractArray{<:AbstractArray{<:Any, N}, M}, outerdims::NTuple{M, Int}) where {N, M} = _combinedims(a, Val(outerdims))

function _combinedims(a::AbstractArray, ::Val{outer_dims}) where {outer_dims}
    outeraxes = axes(a)
    inneraxes = _inneraxes(a)
    ndims_total = length(outeraxes) + length(inneraxes)
    newaxes = _combine_tuples(ndims_total, outer_dims, outeraxes, inneraxes)

    T = inner_eltype(a)
    out = similar(a, T, newaxes)
    for j in CartesianIndices(outeraxes)
        I = slice_inds(j, Val(outer_dims), Val(ndims_total))
        view(out, I...) .= a[j]
    end
    return out
end

@inline function _combine_tuples(n, dims, t_then, t_else)
    i_out = Ref(0)
    i_in = Ref(0)
    ntuple(n) do i
        i ∈ dims ? t_then[i_out[] += 1] : t_else[i_in[] += 1]
    end
end

_inneraxes(a) = axes(first(a)) # Can specialize this for static arrays, for example

inner_eltype(a) = Any
inner_eltype(a::AbstractArray{<:AbstractArray{T}}) where {T} = T


## Lazy version

struct CombineDimsArray{T, N, Nout, A} <: AbstractArray{T, N}
    parent::A
    outer_dims::NTuple{Nout, Int}
end

Base.parent(a::CombineDimsArray) = a.parent

@inline dims_outer(a::CombineDimsArray) = a.outer_dims
@inline function dims_inner(a::CombineDimsArray{T, N, Nout}) where {T, N, Nout}
    # below is a type-stable version of:
    # filter(∉(dims_outer(a)), ntuple(identity, N))
    i = Ref(0)
    ntuple(N - Nout) do _
        i[] = findnext(∉(dims_outer(a)), 1:N, i[] + 1)::Int  # ::Int annotation for type stability: we know that the result isn't nothing
    end
end

Base.size(a::CombineDimsArray) = _combine_tuples(ndims(a), dims_outer(a), size(parent(a)), size(first(parent(a))))
axes(a::CombineDimsArray) = _combine_tuples(ndims(a), dims_outer(a), axes(parent(a)), axes(first(parent(a))))
Base.IndexStyle(::CombineDimsArray) = Base.IndexCartesian()
@propagate_inbounds function Base.getindex(a::CombineDimsArray{T, N}, i::Vararg{Int, N}) where {T, N}
    outer_inds = getindices(i, dims_outer(a))
    inner_inds = getindices(i, dims_inner(a))
    return parent(a)[outer_inds...][inner_inds...]
end

@propagate_inbounds function Base.setindex!(a::CombineDimsArray{T, N}, val, i::Vararg{Int, N}) where {T, N}
    outer_inds = getindices(i, dims_outer(a))
    inner_inds = getindices(i, dims_inner(a))
    parent(a)[outer_inds...][inner_inds...] = val
end

"""
    combinedimsview(array_of_arrays)

Lazily create a flat array view of a nested array structure.

This is the inverse operation of `splitdims` / `splitdimsview`.

See also `combinedims`, the eager version of this function.
"""
combinedimsview(a::AbstractArray{<:AbstractArray{T, N}, M}) where {T, N, M} = combinedimsview(a, ntuple(i -> N + i, Val(M)))
combinedimsview(a::AbstractArray{<:AbstractArray{T, N}, 1}, outerdim::Int) where {T, N} = combinedimsview(a, (outerdim,))
combinedimsview(a::AbstractArray{<:AbstractArray{T, N}, M}, outerdims::NTuple{M, Int}) where {T, N, M} = CombineDimsArray{inner_eltype(a), N + M, M, typeof(a)}(a, outerdims)

module SplitApplyCombine

using Base: @propagate_inbounds, @pure, promote_op, Callable
using Indexing
using Dictionaries
import Dictionaries: filterview

import Base: merge, merge!, size, IndexStyle, getindex, parent, axes, iterate

# collections -> collections
export mapmany, mapview, MappedIterator, MappedArray, product, productview, ProductArray, filterview

# collections -> collections of collections
export group, groupfind, GroupDictionary, groupview, groupreduce, groupcount, groupsum, groupprod, groupunique, grouponly, groupfirst, grouplast
export splitdims, splitdimsview, SplitDimsArray

# colletions of collections -> collections
export flatten #, flattenview
export combinedims, combinedimsview, CombineDimsArray

# collections of collections -> collections of collections
export invert, invert! # a "transpose" for nested containers
export innerjoin, ⨝, leftgroupjoin

@inline former(a, b) = a
@inline latter(a, b) = b

include("map.jl")
include("group.jl")
include("product.jl")
include("innerjoin.jl")
include("leftgroupjoin.jl")
include("splitdims.jl")
include("combinedims.jl")
include("invert.jl")

end # module

"""
    splitdims(array, [dims])

Eagerly split the contents of `array` into a nested array of arrays. The outermost
array contains the specified dimension(s) `dims`, which may be an integer, a
tuple of integers, or defaults to the final array dimension. The nested arrays
will contain all the remaining dimensions (in ascending order).

See also `splitdimsview`, which performs a similar operation lazily.

#### Examples:

```julia
julia> splitdims([1 2; 3 4])
2-element Array{Array{Int64,1},1}:
 [1, 3]
 [2, 4]

julia> splitdims([1 2; 3 4], 1)
2-element Array{Array{Int64,1},1}:
 [1, 2]
 [3, 4]
```
"""
@inline splitdims(a::AbstractArray, i::Int) = _splitdims(a, Val((i,))) # @inline forces constant propagation
@inline splitdims(a::AbstractArray) = _splitdims(a, Val((ndims(a),)))
@inline splitdims(a::AbstractArray{<:Any, 0}) = _splitdims(a, Val(()))
@inline splitdims(a::AbstractArray, dims::Tuple{Vararg{Int}}) = _splitdims(a, Val(dims))

function _splitdims(a::AbstractArray{<:Any, n}, ::Val{dims}) where {n, dims}
    innerdims = default_innerdims(dims, n)
    check_dims(Val(n), Val(dims), Val(innerdims))

    allaxes = axes(a)
    outeraxes = getindices(allaxes, dims)
    inneraxes = getindices(allaxes, innerdims)

    local out
    alloc = false
    for i in CartesianIndices(outeraxes)
        inds = slice_inds(i, Val(dims), Val(n))
        tmp = getindices(a, inds...)
        if !alloc
            out = similar(a, typeof(tmp), outeraxes)
            alloc = true
        end
        out[i] = tmp
    end
    return out
end

@pure function default_innerdims(dims::Tuple{Vararg{Int}}, n::Int)
    t = ()
    for i in 1:n
        if !(i in dims)
            t = (i, t...)
        end
    end
    return t
end

@generated function check_dims(::Val{n}, ::Val{dims}, ::Val{innerdims}) where {n, dims, innerdims}
    d = (dims..., innerdims...)
    if length(d) != n
        error("Incorrect dimensions")
    end
    for i in 1:n
        if !(i in d)
            error("Incorrect dimensions")
        end
    end
    return nothing
end

@generated function slice_inds(i::CartesianIndex, ::Val{dims}, ::Val{n}) where {dims, n}
    @assert length(i) == length(dims)
    out = []
    for j in 1:n
        k = findfirst(==(j), dims)
        if k === nothing
            out = [out..., :]
        else
            out = [out..., :(i[$k])]
        end
    end
    return :(tuple($(out...)))
end

## Lazy version

struct SplitDimsArray{T, N, Dims, A} <: AbstractArray{T, N}
    parent::A
end

Base.parent(a::SplitDimsArray) = a.parent

axes(a::SplitDimsArray{T, N, Dims}) where {T, N, Dims} = getindices(axes(parent(a)), Dims)
size(a::SplitDimsArray{T, N, Dims}) where {T, N, Dims} = getindices(size(parent(a)), Dims)
Base.IndexStyle(::SplitDimsArray) = Base.IndexCartesian()
@propagate_inbounds function Base.getindex(a::SplitDimsArray{T, N, Dims}, i::Vararg{Int, N}) where {T, N, Dims}
    return view(parent(a), slice_inds(CartesianIndex(i), Val(Dims), Val(ndims(parent(a))))...)
end

"""
    splitdimsview(array, [dims])

Lazily split the contents of `array` into a nested array of arrays. The outermost
array contains the specified dimension(s) `dims`, which may be an integer, a
tuple of integers, or defaults to the final array dimension. The nested arrays
will contain all the remaining dimensions (in ascending order).

See also `splitdims`, which performs a similar operation eagerly.

#### Examples:

```julia
julia> splitdims([1 2; 3 4])
2-element SplitDimsArray{SubArray{Int64,1,Array{Int64,2},Tuple{Base.Slice{Base.OneTo{Int64}},Int64},true},1,(2,),Array{Int64,2}}:
 [1, 3]
 [2, 4]

julia> splitdims([1 2; 3 4], 1)
2-element SplitDimsArray{SubArray{Int64,1,Array{Int64,2},Tuple{Int64,Base.Slice{Base.OneTo{Int64}}},true},1,(1,),Array{Int64,2}}:
 [1, 2]
 [3, 4]
```
"""
@inline splitdimsview(a::AbstractArray) = SplitDimsArray{new_eltype(typeof(a), Val((ndims(a),))), 1, (ndims(a),), typeof(a)}(a)
@inline splitdimsview(a::AbstractArray{<:Any, 0}) = SplitDimsArray{new_eltype(typeof(a), Val(())), 0, (), typeof(a)}(a)
@inline splitdimsview(a::AbstractArray, i::Int) = SplitDimsArray{new_eltype(typeof(a), Val((i,))), 1, (i,), typeof(a)}(a)
@inline function splitdimsview(a::AbstractArray{<:Any, N}, dims::NTuple{M, Int}) where {N, M}
    SplitDimsArray{new_eltype(typeof(a), Val(dims)), M, dims, typeof(a)}(a)
end

function new_eltype(::Type{A}, ::Val{Dims}) where {A, Dims}
    return Core.Compiler.return_type(view, splat_inds(Tuple{A, Core.Compiler.return_type(slice_inds, Tuple{CartesianIndex{length(Dims)}, Val{Dims}, Val{ndims(A)}})}))
end

@pure function splat_inds(::Type{T}) where {T <: Tuple}
    a = T.parameters[1]
    b = T.parameters[2].parameters
    return Tuple{a, b...}
end

@testset "product" begin
    @test @inferred(product(*, [1,2], [1,2,3]))::Matrix{Int} == [1 2 3; 2 4 6]
    @test @inferred(product(*, [1.0,2.0], [1,2,3]))::Matrix{Float64} == [1.0 2.0 3.0; 2.0 4.0 6.0]
    @test isequal(product(*, [1.0,2.0], [1,2,missing]), [1.0 2.0 missing; 2.0 4.0 missing])
    @test isequal(@inferred(product(*, [1.0,2.0], [1,2,missing]))::Matrix{Union{Missing, Float64}}, [1.0 2.0 missing; 2.0 4.0 missing])

    @test @inferred(product(+, fill(1), fill(1)))::Array{Int, 0} == fill(2)
    @test @inferred(product(+, [0,1,2], fill(1)))::Array{Int, 1} == [1,2,3]
    @test @inferred(product(+, fill(1), [0,1,2]))::Array{Int, 1} == [1,2,3]
    @test @inferred(product(+, fill(1), [1 2; 3 4]))::Array{Int, 2} == [2 3; 4 5]
    @test @inferred(product(+, [1 2; 3 4], fill(1)))::Array{Int, 2} == [2 3; 4 5]
    @test size(@inferred(product(+, [1 2 3; 4 5 6], zeros(Int, 4, 5)))::Array{Int, 4}) == (2,3,4,5)
end

@testset "productview" begin
    @test @inferred(productview(*, [1,2], [1,2,3]))::ProductArray{Int,2} == [1 2 3; 2 4 6]
    @test @inferred(productview(*, [1.0,2.0], [1,2,3]))::ProductArray{Float64,2} == [1.0 2.0 3.0; 2.0 4.0 6.0]
    @test isequal(productview(*, [1.0,2.0], [1,2,missing])::ProductArray, [1.0 2.0 missing; 2.0 4.0 missing])
    @test isequal(@inferred(productview(*, [1.0,2.0], [1,2,missing]))::ProductArray{Union{Missing, Float64},2}, [1.0 2.0 missing; 2.0 4.0 missing])

    @test @inferred(productview(+, fill(1), fill(1)))::ProductArray{Int, 0} == fill(2)
    @test @inferred(productview(+, [0,1,2], fill(1)))::ProductArray{Int, 1} == [1,2,3]
    @test @inferred(productview(+, fill(1), [0,1,2]))::ProductArray{Int, 1} == [1,2,3]
    @test @inferred(productview(+, fill(1), [1 2; 3 4]))::ProductArray{Int, 2} == [2 3; 4 5]
    @test @inferred(productview(+, [1 2; 3 4], fill(1)))::ProductArray{Int, 2} == [2 3; 4 5]
    @test size(@inferred(productview(+, [1 2 3; 4 5 6], zeros(Int, 4, 5)))::ProductArray{Int, 4}) == (2,3,4,5)
end

"""
    mapmany(f, a...)

Like `map`, but `f(x)` for each `x ∈ a` may return an arbitrary number of values to insert
into the output.

# Example

```jldoctest
julia> mapmany(x -> 1:x, [1,2,3])
6-element Array{Int64,1}:
 1
 1
 2
 1
 2
 3
```
"""
function mapmany(f::Callable, a)
    T = eltype(promote_op(f, eltype(a)))
    out = T[]
    for x ∈ a
        append!(out, f(x))
    end
    return out
end

mapmany(f::Callable, a, b, c...) = mapmany(x->f(x...), zip(a, b, c...))

"""
    flatten(a)

Takes a collection of collections `a` and returns a collection containing all the elements
of the subcollecitons of `a`. Equivalent to `mapmany(idenity, a)`.

# Example

```jldoctest
julia> flatten([1:1, 1:2, 1:3])
6-element Array{Int64,1}:
 1
 1
 2
 1
 2
 3
```
"""
flatten(x) = mapmany(identity, x) 

struct MappedIterator{F, T}
	f::F
	parent::T
end
@inline function iterate(it::MappedIterator)
	x = iterate(it.parent)
	return x === nothing ? nothing : (it.f(x[1]), x[2])
end
@inline function iterate(it::MappedIterator, i)
	x = iterate(it.parent, i)
	return x === nothing ? nothing : (it.f(x[1]), x[2])
end

# Inherit any iteration and indexing properties from parent
Base.IteratorSize(it::MappedIterator) = Base.IteratorSize(it.parent)
Base.length(it::MappedIterator) = length(it.parent)
Base.size(it::MappedIterator) = size(it.parent)
Base.axes(it::MappedIterator) = axes(it.parent)
Base.keys(it::MappedIterator) = keys(it.parent)
@propagate_inbounds Base.getindex(it::MappedIterator, i) = it.parent[i]

struct MappedArray{T, N, F, A <: AbstractArray{<:Any, N}} <: AbstractArray{T, N}
	f::F
	parent::A
end
parent(a::MappedArray) = a.parent
size(a::MappedArray) = size(a.parent)
axes(a::MappedArray) = axes(a.parent)
IndexStyle(a::MappedArray) = IndexStyle(a.parent)
@propagate_inbounds getindex(a::MappedArray{T}, i::Int) where {T} = a.f(a.parent[i])::T
@propagate_inbounds getindex(a::MappedArray{T}, i::Int...) where {T} = a.f(a.parent[i...])::T

"""
    mapview(f, a)

Return a view of `a` where each element is mapped through function `f`. The iteration and
indexing properties of `a` are preserved. Similar to `map(f, a)`, except evaluated lazily.

# Example

```julia
julia> a = [1,2,3];

julia> b = mapview(-, a)
3-element MappedArray{Int64,1,typeof(-),Array{Int64,1}}:
 -1
 -2
 -3

julia> a[1] = 10;

julia> b
3-element MappedArray{Int64,1,typeof(-),Array{Int64,1}}:
 -10
  -2
  -3
```
"""
mapview(f, a) = MappedIterator(f, a)
mapview(f, a::AbstractArray{T, N}) where {T, N} = MappedArray{promote_op(f, T), N, typeof(f), typeof(a)}(f, a)
function mapview(f, d::AbstractDictionary)
    I = keytype(d)
    T = Core.Compiler.return_type(f, Tuple{eltype(d)})
    
    return MappedDictionary{I, T, typeof(f), Tuple{typeof(d)}}(f, (d,))
end

mapview(::typeof(identity), a) = a
mapview(::typeof(identity), a::AbstractArray) = a
mapview(::typeof(identity), d::AbstractDictionary) = d

"""
    filterview(f, a)

Return a view of an array `a` without elements for which `f` is `false`. Similar to `filter(f, a)`, except returns a view instead of a copy.
Filtered indices are computed once, and are not updated when the array gets modified.

# Example

```
julia> a = [1, 2, 3];

julia> b = filterview(isodd, a)
2-element view(::Vector{Int64}, [1, 3]) with eltype Int64:
 1
 3

julia> b[2] = 10;

julia> a
3-element Vector{Int64}:
  1
  2
 10

julia> b
2-element view(::Vector{Int64}, [1, 3]) with eltype Int64:
  1
 10
```
"""
filterview(f, a::AbstractArray) = @view a[findall(f, a)]

@testset "mapmany" begin
    @test mapmany(i->1:i, 1:3) == [1, 1,2, 1,2,3]
    @test mapmany((i,j)->1:(i+j), 1:3, 1:3) == [1,2, 1,2,3,4, 1,2,3,4,5,6]
end

@testset "flatten" begin
    @test flatten([1:1, 1:2, 1:3]) == [1, 1,2, 1,2,3]
end

@testset "mapview" begin
    # Arrays
    a = [1,2,3]
    @test @inferred(mapview(-, a)) isa MappedArray{Int,1}
    b = mapview(-, a)
    @test b == [-1,-2,-3]
    a[1] = 11
    @test b == [-11,-2,-3]

    # Iterables
    iter = zip([1,2,3], [1,2,3])
    iter2 = mapview(x -> x[1] + x[2], iter)
    @test @inferred(first(iter2)) === 2
    @test collect(iter2) == [2, 4, 6]
end

@testset "filterview" begin
    a = [1, 2, 3]
    @test @inferred(filterview(x -> x >= 2, a)) == [2, 3]
    filterview(x -> x >= 2, a)[1] = 10
    @test a == [1, 10, 3]
end

@testset "invert" begin
    # arrays of arrays
    a = [[1,2,3],[4,5,6]]
    @test @inferred(invert(a))::Vector{Vector{Int}} == [[1,4],[2,5],[3,6]]
    
    b = [[0,0],[0,0],[0,0]]
    @test invert!(b, a) == [[1,4],[2,5],[3,6]]

    # Issue #14
    a3 = [[1 2; 3 4],[5 6; 7 8]]
    result3 = Matrix{Vector{Int}}(undef,2,2) # literal syntax is `hvcat`... :(
    result3[1, 1] = [1, 5]
    result3[1, 2] = [2, 6]
    result3[2, 1] = [3, 7]
    result3[2, 2] = [4, 8]
    @test @inferred(invert(a3))::Matrix{Vector{Int}} == result3

    # tuples of tuples
    tt = ((true, 2.0, 3f0), ('d', 0x05, 6))
    @test @inferred(invert(tt)) === ((true, 'd'), (2.0, 0x05), (3f0, 6))

    # tuples / arrays
    ta = ([1, 2], [3.1, 4.1])
    at = [(1, 3.1), (2, 4.1)]
    @test @inferred(invert(ta))::Vector{Tuple{Int, Float64}} == at
    @test @inferred(invert(at))::Tuple{Vector{Int}, Vector{Float64}} == ta

    # named tuples
    nn = (a = (x = true, y = 2), b = (x = 3.0, y = 4.0f0))
    @test @inferred(invert(nn)) === (x = (a = true, b = 3.0), y = (a = 2, b = 4.0f0))

    # tuples / named tuples
    tn = ((a = true, b = 2), (a = 3.0, b = 4.0f0))
    nt = (a = (true, 3.0), b = (2, 4.0f0))
    @test @inferred(invert(nt)) === tn
    @test @inferred(invert(tn)) === nt

    # arrays / named tuples
    na = (a = [1,2,3], b = [2.0, 4.0, 6.0])
    an = [(a = 1, b = 2.0), (a = 2, b = 4.0), (a = 3, b = 6.0)]
    @test @inferred(invert(na))::typeof(an) == an
    @test @inferred(invert(an))::typeof(na) == na
end

"""
    group(iter)
    group(by::Union{Function, Type}, iter)
    group(by::Union{Function, Type}, f::Union{Function, Type}, iter...)

Return a dictionary of groups of elements `x` of the iterable `iter` into groups labeled by
`by(x)`, transforming each element to `f(x)`, where `by` and `f` default to the `identity`
function. If multiple collections (of the same length) are provided, the transformations
`by` and `f` occur elementwise.

# Example

```jldoctest
julia> group(iseven, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
Dictionary{Bool,Array{Int64,1}} with 2 entries:
 false │ [1, 3, 5, 7, 9]
 true  │ [2, 4, 6, 8, 10]

julia> group(iseven, x -> x ÷ 2, [1, 2, 3, 4, 5, 6, 7, 8, 9, 10])
Dictionary{Bool,Array{Int64,1}} with 2 entries:
 false │ [0, 1, 2, 3, 4]
 true  │ [1, 2, 3, 4, 5]
```
"""
group(iter) = group(iter, iter)
group(by::Callable, iter) = group(mapview(by, iter), iter)
group(by::Callable, f::Callable, iter) = group(mapview(by, iter), mapview(f, iter))

# TODO multi-input mapview
#group(by::Callable, f::Callable, iter1, iter2) = group(mapview(by, iter1, iter2), mapview(f, iter1, iter2))
#group(by::Callable, f::Callable, iter1, iter2, iters...) = group(mapview(by, iter1, iter2, iters...), mapview(f, iter1, iter2, iters...))
group(by::Callable, f::Callable, iter1, iter2, iters...) = group((x -> by(x...)), (x -> f(x...)), zip(iter1, iter2, iters...))

"""
    group(groups, values)

Return a dictionary of the elements of `values` grouped by the label inidcated by by the
matching element from `groups`.

# Example

```julia
julia> group([true,false,true,false,true], [1,2,3,4,5])
2-element Dictionary{Bool,Array{Int64,1}}
  true │ [1, 3, 5]
 false │ [2, 4]
```
"""
function group(groups, values)
    I = eltype(groups) # TODO EltypeUnknown
    T = eltype(values) # TODO EltypeUnknown

    out = Dictionary{I, Vector{T}}()
    @inbounds for (group, value) in zip(groups, values)
        tmp = get!(() -> T[value], out, group)
        last(tmp) == value || push!(tmp, value)
    end

    return out
end

function group(groups::AbstractVector, values::AbstractVector)
    I = eltype(groups)
    T = eltype(values)

    if keys(groups) != keys(values)
        throw(DimensionMismatch("dimensions must match"))
    end

    VT = Core.Compiler.return_type(Base.emptymutable, Tuple{typeof(values)})
    out = Dictionary{I, VT}()
    @inbounds for i in keys(groups)
        group = groups[i]
        value = values[i]
        push!(get!(() -> Base.emptymutable(values), out, group), value)
    end

    return out
end

function group(groups::AbstractDictionary, values::AbstractDictionary)
    I = eltype(groups)
    T = eltype(values)

    out = Dictionary{I, Vector{T}}()

    if sharetokens(groups, values)
        @inbounds for token in tokens(groups)
            group = gettokenvalue(groups, token)
            value = gettokenvalue(values, token)
            push!(get!(Vector{T}, out, group), value)
        end
    else
        if length(groups) != length(values)
            throw(KeyError("Indices must match"))
        end

        for (i, group) in pairs(groups)
            value = values[i]
            push!(get!(Vector{T}, out, group), value)
        end
    end

    return out
end


"""
    groupreduce(by, f, op, iter...; [init])

Applies a `mapreduce`-like operation on the groupings labeled by passing the elements of
`iter` through `by`. Mostly equivalent to `map(g -> reduce(op, g), group(by, f, iter))`,
but designed to be more efficient. If multiple collections (of the same length) are
provided, the transformations `by` and `f` occur elementwise.
"""
groupreduce(by::Callable, op::Callable, iter) = groupreduce(by, identity, op, iter)

groupreduce(by::Callable, f::Callable, op::Callable, iter1, iter2, iters...; kw...) = groupreduce((x -> by(x...)), (x -> f(x...)), op, zip(iter1, iter2, iters...); kw...)

function groupreduce(by::Callable, f::Callable, op::Callable, iter; kw...)
    groupreduce(op, mapview(by, iter), mapview(f, iter); kw...)
end

function groupreduce(op::Callable, groups, values; kw...)
    I = eltype(groups)
    nt = Base.values(kw)
    if nt isa NamedTuple{()}
        T = eltype(values)
    elseif nt isa NamedTuple{(:init,)}
        T = Core.Compiler.return_type(op, Tuple{typeof(nt.init), eltype(values)})
    else
        throw(ArgumentError("groupreduce doesn't support these keyword arguments: $(setdiff(keys(nt), (:init,)))"))
    end

    out = Dictionary{I, T}()
    @inbounds for (group, value) in zip(groups, values)
        (hadtoken, token) = gettoken!(out, group)
        if hadtoken
            settokenvalue!(out, token, op(gettokenvalue(out, token), value))
        else
            if nt isa NamedTuple{()}
                settokenvalue!(out, token, value)
            else
                settokenvalue!(out, token, op(nt.init, value))
            end
        end
    end

    return out
end

"""
    groupsum(by, [f], iter)

Sum the elements of `iter` belonging to different groups, optionally mapping by `f`.
"""
groupsum(iter) = groupsum(identity, iter)
groupsum(by::Callable, iter) = groupsum(by, identity, iter)
groupsum(by::Callable, f::Callable, iter) = groupreduce(by, f, +, iter)

"""
    groupprod(by, [f], iter)

Multiply the elements of `iter` belonging to different groups, optionally mapping by `f`.
"""
groupprod(iter) = groupprod(identity, iter)
groupprod(by::Callable, iter) = groupprod(by, identity, iter)
groupprod(by::Callable, f::Callable, iter) = groupreduce(by, f, *, iter)

"""
    groupcount([by], iter)

Determine the number of elements of `iter` belonging to each group.
"""
groupcount(by::Callable, iter) = groupreduce(by, x->1, +, iter)
groupcount(iter) = groupcount(identity, iter) # A handy extension of `unique`

"""
    groupfirst([by], [f], iter)

Find the first element of each grouping.
"""
groupfirst(iter) = groupreduce(identity, identity, former, iter)
groupfirst(by::Callable, iter) = groupreduce(by, identity, former, iter)
groupfirst(by::Callable, f::Callable, iter) = groupreduce(by, f, former, iter)
groupfirst(groups, values) = groupreduce(former, groups, values)

"""
    grouplast([by], [f], iter)

Find the last element of each grouping.
"""
grouplast(iter) = groupreduce(identity, identity, latter, iter)
grouplast(by::Callable, iter) = groupreduce(by, identity, latter, iter)
grouplast(by::Callable, f::Callable, iter) = groupreduce(by, f, latter, iter)
grouplast(groups, values) = groupreduce(latter, groups, values)


"""
    grouponly([by], [f], iter)

Return a dictionary mapping the unique elements `x` of iter grouped by `by(x)` with value
`f(x)`, where `by` and `f` default to the identity function.

This is an optimized equivalent of `only.(group(by, f, iter))` and is similar to
`Dictionary(by.(iter), f.(iter))`
"""
grouponly(iter) = grouponly(identity, iter)

grouponly(by::Callable, iter) = grouponly(by, identity, iter)

grouponly(by::Callable, f::Callable, iter) = grouponly(mapview(by, iter), mapview(f, iter))

"""
    grouponly(groups, values)

This is an optimized equivalent of `only.(group(groups, values))`.
"""
grouponly(groups, values) = Dictionary(groups, values)
# should make this more generic... if `groups` is an `AbstractIndices` we can use `similar`
# to generate the output...

"""
    groupunique([by], [f], iter)

Return a dictionary mapping the sets of elements `x` of iter grouped by `by(x)` with values
`f(x)`, where `by` and `f` default to the identity function.

This is similar to `unique.(group(by, f, iter))` but each subgroup is an `AbstractIndices`
of distinct values (rather than an `AbstractArray` with possibly repeated values).

# Example

```julia
julia> groupunique(iseven, [1,2,1,2,3])
2-element Dictionary{Bool,Indices{Int64}}
 false │ {2}
  true │ {1, 3}
```
"""
groupunique(iter) = groupunique(identity, iter)
groupunique(by::Callable, iter) = groupunique(by, identity, iter)
groupunique(by::Callable, f::Callable, iter) = groupunique(mapview(by, iter), mapview(f, iter))


"""
    groupunique(groups, values)

Collect the unique elements of `values` by the corresponding element of `groups`, returning
a dictinary of sets.

# Example

```julia
julia> groupunique([true,false,true,false,true], [1,2,1,2,3])
2-element Dictionary{Bool,Indices{Int64}}
  true │ {1, 3}
 false │ {2}
```
"""
function groupunique(groups, values)
    I = eltype(groups)
    T = eltype(values)

    out = Dictionary{I, Indices{T}}()
    for (group, value) in zip(groups, values)
        grouping = get!(Indices{T}, out, group)
        set!(grouping, value)
    end

    return out
end

@deprecate groupinds groupfind

"""
    groupfind([by], container)

Seperate the indices `i` of `container` into groups labeled by `by(container[i])`, where the
default value of `by` is `identity`.

# Example

```jldoctest
julia> groupfind(iseven, [3,4,2,6,5,8])
2-element Dictionary{Bool,Array{Int64,1}}
 false │ [1, 5]
  true │ [2, 3, 4, 6]
```
"""
groupfind(by::Callable, container) = groupfind(mapview(by, container))

function groupfind(container)
    I = eltype(container)
    T = keytype(container)

    out = Dictionary{I, Vector{T}}()
    @inbounds for i in keys(container)
        tmp = get!(() -> T[i], out, container[i])
        last(tmp) == i || push!(tmp, i)
    end
    return out
end

function groupfind(inds::AbstractIndices)
    I = eltype(inds)
    T = keytype(inds)

    out = Dictionary{I, Vector{T}}()
    for i in inds
        tmp = get!(() -> T[i], out, container[i])
        last(tmp) == i || push!(tmp, i)
    end
    return out
end

function groupfind(dict::AbstractDictionary)
    I = eltype(dict)
    T = keytype(dict)

    inds = keys(dict)
    out = Dictionary{I, Vector{T}}()
    @inbounds if istokenizable(dict)
        for t in tokens(dict)
            tmp = get!(Vector{T}, out, gettokenvalue(dict, t))
            push!(tmp, gettokenvalue(inds, t))
        end
    else
        for i in inds
            tmp = get!(Vector{T}, out, dict[i])
            push!(tmp, i)
        end
    end
    return out
end

# Semi-lazy grouping container (TODO docstring)
struct GroupDictionary{I, T, Parent, Inds <: AbstractDictionary{I}} <: AbstractDictionary{I, T}
    parent::Parent
    inds::Inds
end

Base.parent(g::GroupDictionary) = getfield(g, :parent)
_inds(g::GroupDictionary) = getfield(g, :inds)
Base.keys(g::GroupDictionary) = keys(_inds(g))

Base.isassigned(g::GroupDictionary{I}, k::I) where {I} = isassigned(_inds(g), k)
Base.@propagate_inbounds function Base.getindex(g::GroupDictionary{I}, i::I) where {I}
    inds = _inds(g)[i]
    return view(parent(g), inds)
end

Dictionaries.tokentype(g::GroupDictionary) = tokentype(_inds(g))
@propagate_inbounds Dictionaries.gettoken(g::GroupDictionary{I}, i::I) where {I} = gettoken(_inds(g), i)
Dictionaries.istokenassigned(g::GroupDictionary, t) = istokenassigned(_inds(g), t)
@propagate_inbounds function Dictionaries.gettokenvalue(g::GroupDictionary, t)
    inds = gettokenvalue(_inds(g), t)
    return view(parent(g), inds)
end

"""
    groupview([by], container)

Like `group`, but each grouping is a `view` of the indexable input `container`.

# Example

```jldoctest
julia> v = [3,4,2,6,5,8]
6-element Array{Int64,1}:
 3
 4
 2
 6
 5
 8

julia> groups = groupview(iseven, v)
2-element GroupDictionary{Bool,SubArray{Int64,1,Array{Int64,1},Tuple{Array{Int64,1}},false},Array{Int64,1},Dictionary{Bool,Array{Int64,1}}}
 false │ [3, 5]
  true │ [4, 2, 6, 8]

julia> groups[false] .= 99  # set all the odd values to 99
2-element view(::Array{Int64,1}, [1, 5]) with eltype Int64:
 99
 99

julia> v
6-element Array{Int64,1}:
 99
  4
  2
  6
 99
  8
```
"""
groupview(container) = groupview(identity, container)
function groupview(by::Callable, container)
    inds = groupfind(by, container)
    T = typeof(container)
    V = Core.Compiler.return_type(view, Tuple{T, eltype(inds)})
    return GroupDictionary{keytype(inds), V, T, typeof(inds)}(container, inds)
end

@testset "leftgroupjoin" begin
    l = [1,2,3,4]
    r = [0,1,2]
    ans1 = dictionary([1 => [(1,1)],
                       2 => [(2,2)],
                       3 => [],
                       4 => []]) 
    ans2 = dictionary([false => [(1, 1), (3, 1)],
                       true => [(2, 0), (2, 2), (4, 0), (4, 2)]])

    @test leftgroupjoin(identity, identity, tuple, l ,r) == ans1
    @test leftgroupjoin(iseven, iseven, tuple, l,  r) == ans2
    @test leftgroupjoin(iseven, iseven, tuple, ==, l, r) == ans2
end

# Join works on collections of collections (e.g. a table is a collection of
# rows).

innerjoin(left, right) = innerjoin(identity, identity, left, right)
innerjoin(lkey::Callable, rkey::Callable, left, right) = innerjoin(lkey, rkey, merge, left, right)
innerjoin(lkey::Callable, rkey::Callable, f::Callable, left, right) = innerjoin(lkey, rkey, f, isequal, left, right)

const ⨝ = innerjoin

"""
    innerjoin(lkey, rkey, f, comparison, left, right)

Performs a relational-style join operation between iterables `left` and `right`, returning
a collection of elements `f(l, r)` for which `comparison(lkey(l), rkey(r))` is `true` where
`l ∈ left`, `r ∈ right.`

# Example

```jldoctest
julia> innerjoin(iseven, iseven, tuple, ==, [1,2,3,4], [0,1,2])
6-element Array{Tuple{Int64,Int64},1}:
 (1, 1)
 (2, 0)
 (2, 2)
 (3, 1)
 (4, 0)
 (4, 2)
```
"""
function innerjoin(lkey::Callable, rkey::Callable, f::Callable, comparison::Callable, left, right)
    # TODO Do this inference-free, like comprehensions...
    T = promote_op(f, eltype(left), eltype(right))
    out = empty(left, T)

    innerjoin!(out, lkey, rkey, f, comparison, left, right)
    return out
end

function innerjoin!(out, lkey::Callable, rkey::Callable, f::Callable, comparison::Callable, left, right)
    # The O(length(left)*length(right)) generic method when nothing about `comparison` is known
    for a ∈ left
        for b ∈ right
            if comparison(lkey(a), rkey(b))
                push!(out, f(a, b))
            end
        end
    end
    return out
end

function innerjoin!(out, lkey::Callable, rkey::Callable, f::Callable, ::typeof(isequal), left, right)
    # isequal heralds a hash-based approach, roughly O(length(left) * log(length(right)))

    if Base.IteratorSize(left) === Base.SizeUnknown() || Base.IteratorSize(right) === Base.SizeUnknown() || length(right) <= length(left)
        K = promote_op(rkey, eltype(right))
        V = eltype(right)
        dict = Dict{K,Vector{V}}() # maybe a different stategy if right is unique?
        for b ∈ right
            key = rkey(b)
            push!(get!(Vector{V}, dict, key), b)
        end

        @inbounds for a ∈ left
            key = lkey(a)
            dict_index = Base.ht_keyindex(dict, key)
            if dict_index > 0 # -1 if key not found
                for b ∈ dict.vals[dict_index]
                    push!(out, f(a, b))
                end
            end
        end
    else
        K = promote_op(lkey, eltype(left))
        V = eltype(left)
        dict = Dict{K,Vector{V}}() # maybe a different stategy if left is unique?
        for a ∈ left
            key = lkey(a)
            push!(get!(Vector{V}, dict, key), a)
        end

        @inbounds for b ∈ right
            key = rkey(b)
            dict_index = Base.ht_keyindex(dict, key)
            if dict_index > 0 # -1 if key not found
                for a ∈ dict.vals[dict_index]
                    push!(out, f(a, b))
                end
            end
        end
    end

    return out
end

# For arrays, the assumptions around the below are
#  * Accessing arrays via indices and mapviews should be similar in speed to the above
#  * We can specialize these methods on particular arrays - works well for TypedTables.Table
#    of AcceleratedArrays.AcceleratedArray

function innerjoin!(out, lkey::Callable, rkey::Callable, f::Callable, comparison::Callable, left::AbstractArray, right::AbstractArray)
    _innerjoin!(out, mapview(lkey, left), mapview(rkey, right), productview(f, left, right), comparison)
end

function innerjoin!(out, lkey::Callable, rkey::Callable, f::Callable, ::typeof(isequal), left::AbstractArray, right::AbstractArray)
    _innerjoin!(out, mapview(lkey, left), mapview(rkey, right), productview(f, left, right), isequal)
end

function _innerjoin!(out, l::AbstractArray, r::AbstractArray, v::AbstractArray, comparison::Callable)
    @boundscheck if (axes(l)..., axes(r)...) != axes(v)
        throw(DimensionMismatch("innerjoin arrays do not have matching dimensions"))
    end

    @inbounds for i_l in keys(l)
        for i_r in keys(r)
            if comparison(l[i_l], r[i_r])
                push!(out, v[Tuple(i_l)..., Tuple(i_r)...])
            end
        end
    end

    return out
end

function _innerjoin!(out, l::AbstractArray, r::AbstractArray, v::AbstractArray, ::typeof(isequal))
    @boundscheck if (axes(l)..., axes(r)...) != axes(v)
        throw(DimensionMismatch("innerjoin arrays do not have matching dimensions"))
    end

    if length(r) <= length(l)
        rkeys = keys(r)
        V = eltype(rkeys)
        dict = Dict{eltype(r), Vector{V}}()
        @inbounds for i_r ∈ rkeys
            push!(get!(Vector{V}, dict, r[i_r]), i_r)
        end

        @inbounds for i_l in keys(l)
            l_value = l[i_l]
            dict_index = Base.ht_keyindex(dict, l_value)
            if dict_index > 0 # -1 if key not found
                for i_r ∈ dict.vals[dict_index]
                    push!(out, v[_tuple(i_l)..., _tuple(i_r)...])
                end
            end
        end
    else
        lkeys = keys(l)
        V = eltype(lkeys)
        dict = Dict{eltype(l), Vector{V}}()
        @inbounds for i_l ∈ lkeys
            push!(get!(Vector{V}, dict, l[i_l]), i_l)
        end

        @inbounds for i_r in keys(r)
            r_value = r[i_r]
            dict_index = Base.ht_keyindex(dict, r_value)
            if dict_index > 0 # -1 if key not found
                for i_l ∈ dict.vals[dict_index]
                    push!(out, v[_tuple(i_l)..., _tuple(i_r)...])
                end
            end
        end
    end

    return out
end

_tuple(i::Integer) = (i,)
_tuple(i::Any) = Tuple(i)


# TODO more specialized methods for comparisons: ==, <, isless, etc - via sorting strategies

# TODO perhaps a better version would be:
# function innerjoin(left, right; lkey = identity, rkey = identity, f = tuple, comparison = isequal)
#     ...
# end

@testset "group" begin
    @test group(identity, 11:20)::Dictionary == Dictionary(11:20, (x->[x]).(11:20))
    @test group(iseven, 1:10)::Dictionary == dictionary([false => [1,3,5,7,9], true => [2,4,6,8,10]])

    @test group(iseven, x -> x*2, 1:10)::Dictionary == dictionary([false => [2,6,10,14,18], true => [4,8,12,16,20]])

    @test group((x,y) -> iseven(x+y), (x,y) -> x, 1:10, [1,3,4,2,5,6,4,2,3,9])::Dictionary == dictionary([true => [1,4,5,6,8,9], false => [2,3,7,10]])

    @test group(isnothing, [1, 2, 3, nothing, 4, 5, nothing])::Dictionary == dictionary([false => [1, 2, 3, 4, 5], true => [nothing, nothing]])
end

@testset "grouponly" begin
    @test grouponly(identity, 11:20)::Dictionary == Dictionary(11:20, 11:20)
    @test_throws IndexError grouponly(iseven, 11:20)
end

@testset "groupunique" begin
    @test groupunique(identity, 11:20)::Dictionary{Int, Indices{Int}} == Dictionary(11:20, map(x -> Indices([x]), 11:20))
    @test groupunique(iseven, 11:20)::Dictionary{Bool, Indices{Int}} == dictionary([false => Indices([11,13,15,17,19]), true => Indices([12,14,16,18,20])])
end

@testset "groupfind" begin
    @test groupfind(identity, 11:20) == Dictionary(11:20, (x->[x]).(1:10))
    @test groupfind(iseven, 11:20) == dictionary([false => [1,3,5,7,9], true => [2,4,6,8,10]])
end

@testset "groupview" begin
    @test groupview(identity, 11:20)::GroupDictionary == group(identity, 11:20)::Dictionary
    @test groupview(iseven, 11:20)::GroupDictionary == group(iseven, 11:20)::Dictionary
end

@testset "groupreduce" begin
    @test groupreduce(identity, +, 1:10) == Dictionary(1:10, 1:10)
    @test groupreduce(iseven, +, 1:10) == dictionary([false => 25, true => 30])

    @test groupreduce(iseven, x -> x*2, +, 1:10) == dictionary([false => 50, true => 60])

    @test groupreduce(iseven, x -> x*2, +, 1:10; init=10) == dictionary([false => 60, true => 70])

    @test groupreduce((x,y) -> iseven(x+y), (x,y) -> x+y, +, 1:10, 1:10; init=10) == dictionary([true => 120])
    @test groupreduce((x,y) -> iseven(x+y), (x,y) -> x+y, +, 1:10, [1,3,4,2,5,6,4,2,3,9]; init=10) == dictionary([true => 62, false => 52])

    @test groupcount(iseven, 1:10) == dictionary([false => 5, true => 5])
    @test groupsum(iseven, 1:10) == dictionary([false => 25, true => 30])
    @test groupprod(iseven, 1:10) == dictionary([false => 1*3*5*7*9, true => 2*4*6*8*10])
    @test groupfirst(iseven, 1:10) == dictionary([false => 1, true => 2])
    @test grouplast(iseven, 1:10) == dictionary([false => 9, true => 10])
end

@testset "innerjoin" begin
    @testset "UnitRange" begin
	    l = 2:5
	    r = 3:6
	    @test innerjoin(identity, identity, tuple, l, r) == [(3,3), (4,4), (5,5)]
	    @test innerjoin(identity, identity, tuple, isequal, l, r) == [(3,3), (4,4), (5,5)]
	    @test innerjoin(identity, identity, tuple, ==, l, r) == [(3,3), (4,4), (5,5)]

	    @test innerjoin(identity, identity, tuple, isless, l, r) == [(2,3), (2,4), (2,5), (2,6), (3,4), (3,5), (3,6), (4,5), (4,6), (5,6)]
	end

	@testset "Arrays of NamedTuple" begin
	    l = [(a=1, b=2.0), (a=2, b=4.0), (a=3, b=6.0)]
	    r = [(a=1, c=:a), (a=2, c=:b), (a=4,c=:d)]
	    @test innerjoin(x->x.a, x->x.a, l, r) == [(a=1, b=2.0, c=:a), (a=2, b=4.0, c=:b)]
	end
end

using SplitApplyCombine
using Dictionaries
using StaticArrays
using Test

include("only.jl")
include("splitdims.jl")
include("combinedims.jl")
include("map.jl")
include("product.jl")
include("group.jl")
include("innerjoin.jl")
include("leftgroupjoin.jl")
include("invert.jl")

@testset "combinedims" begin
    m = [1 5 9; 2 6 10; 3 7 11; 4 8 12]
    vv = [[1,2,3,4],[5,6,7,8],[9,10,11,12]]

    @testset for combine in (combinedims, combinedimsview)
        @test @inferred(size(combine(vv))) == size(m)
        @test @inferred(axes(combine(vv))) == axes(m)
        @test @inferred(combine(vv)) == m
        @test @inferred(combine(vv)[2, 1]) == m[2, 1]
    
        @test @inferred(size(combine(vv, 2))) == size(m)
        @test @inferred(axes(combine(vv, 2))) == axes(m)
        @test @inferred(combine(vv, 2)) == m
        @test @inferred(combine(vv, 2)[2, 1]) == m[2, 1]
        @test @inferred(combine(vv, 1)) == permutedims(m)

        A = rand(2, 3, 5, 7)
        @test @inferred(combine(splitdims(A))) == A
        @testset for d in [1:ndims(A); (1, 2); (1, 3); (2, 3); (2, 4); (1, 2, 3); (1, 2, 4); (2, 3, 4); (1, 2, 3, 4)]
            B = @inferred combine(splitdims(A, d), d)
            @test B == A
            @test @inferred(B[1, 2, 3, 4]) == A[1, 2, 3, 4]

            sum(B); @test @allocated(sum(B)) <= 16  # @btime shows zero allocations, but @allocated always returns at least 16 bytes in this context
        end
    end

    c_copy = combinedims(vv)
    c_view = combinedimsview(vv)
    vv[1][3] = 100
    @test c_copy[3, 1] == 3
    @test c_view[3, 1] == 100
    c_copy[3, 2] = 50
    @test vv[2][3] == 7
    c_view[3, 2] = 50
    @test vv[2][3] == 50
    c_view .= 0; @test @allocated(c_view .= 123) <= 64  # @btime shows zero allocations, but @allocated always returns at least 64 bytes in this context
    @test all(v -> all(==(123), v), vv)

    stat = [SVector(1, 2), SVector(3, 4), SVector(5, 6)]
    @test @inferred(combinedims(stat)) == [1 3 5; 2 4 6]
    # infer to a union:
    @test combinedims(stat, 1) == [1 2; 3 4; 5 6]
    @test combinedims(stat, 2) == [1 3 5; 2 4 6]
    @testset for ds in [(), (1,), (2,)]
        cv = @inferred(combinedimsview(stat, ds...))
        @inferred(size(cv))
        @inferred(cv[1, 2])
    end
end

@testset "only" begin
    @test only([3]) === 3
    @test_throws Exception only([])
    @test_throws Exception only([3, 2])

    @test only((3,)) === 3
    @test_throws Exception only(())
    @test_throws Exception only((3, 2))

    @test only(Dict(1=>3)) === (1=>3)
    @test_throws Exception only(Dict{Int,Int}())
    @test_throws Exception only(Dict(1=>3, 2=>2))
end
